
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import jpype
import jneqsim.neqsim.statistics.experimentalSampleCreation.readDataFromFile
import typing



class WettedWallColumnDataObject(jneqsim.neqsim.statistics.experimentalSampleCreation.readDataFromFile.DataObject):
    def __init__(self): ...
    def getCo2SupplyFlow(self) -> float: ...
    def getColumnWallTemperature(self) -> float: ...
    def getInletGasTemperature(self) -> float: ...
    def getInletLiquidFlow(self) -> float: ...
    def getInletLiquidTemperature(self) -> float: ...
    def getInletTotalGasFlow(self) -> float: ...
    def getOutletGasTemperature(self) -> float: ...
    def getOutletLiquidTemperature(self) -> float: ...
    def getPressure(self) -> float: ...
    def getTime(self) -> int: ...
    def setCo2SupplyFlow(self, double: float) -> None: ...
    def setColumnWallTemperature(self, double: float) -> None: ...
    def setInletGasTemperature(self, double: float) -> None: ...
    def setInletLiquidFlow(self, double: float) -> None: ...
    def setInletLiquidTemperature(self, double: float) -> None: ...
    def setInletTotalGasFlow(self, double: float) -> None: ...
    def setOutletGasTemperature(self, double: float) -> None: ...
    def setOutletLiquidTemperature(self, double: float) -> None: ...
    def setPressure(self, double: float) -> None: ...
    def setTime(self, string: typing.Union[java.lang.String, str]) -> None: ...

class WettedWallDataReader(jneqsim.neqsim.statistics.experimentalSampleCreation.readDataFromFile.DataReader):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str]): ...
    @staticmethod
    def main(stringArray: typing.Union[typing.List[java.lang.String], jpype.JArray]) -> None: ...
    def readData(self) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("jneqsim.neqsim.statistics.experimentalSampleCreation.readDataFromFile.wettedWallColumnReader")``.

    WettedWallColumnDataObject: typing.Type[WettedWallColumnDataObject]
    WettedWallDataReader: typing.Type[WettedWallDataReader]
